
uses chain2,long2;
const
    bufSize=4096;
var inFile,outFile: longText;
    inFilename,outFileName,punctuation,comment: string;
    buffer: chain;
    numRead: word;
    medial: boolean;

function fileExists(fn: string): boolean;
var f: file;
begin assign(f,fn); {$I-} reset(f); {$I+}
      if IOResult=0 then
      begin fileExists:=true; close(f)
      end
      else fileExists:=false;
end;


procedure getParameters;
begin if ParamCount<>1 then
      begin writeln('Usage: ');
            writeln('VMERGE <output file>');
            writeln('For example:');
            writeln('VMERGE VOYNICH.FSG');
            halt;
      end else
      OutFileName:=ParamStr(1);
end;

procedure Splice(var f: longText; var ch: chain);
var c: char;
begin c:=ch.Body_^[ch.hi]; dec(ch.hi);
      ch.write; write('<<'); readln;
      case c of
         #1: if medial then LTWriteln(f);
         #2 (*medial comment*): inc(ch.lo);
         #3 (*medial text*): ;
      end;
      LTWriteChain(f,ch);
      medial:=true;
end;

begin getParameters;
      if FileExists(outfileName) then
      begin
      end;
      LTAssign(infile,'TMP.OUT',4096);
      LTAssign(outfile,outFileName,4096);
      LTReset(infile); LTRewrite(outfile);
      buffer.Init('');
      medial:=false;
      while not LTEof(infile) do
      begin LTReadChain(infile,buffer);
            buffer.write; write('<'); readln;
            Splice(outFile,buffer);
      end;
      LTClose(infile);
      LTClose(outfile);
      Buffer.ReInit('');
end.