uses chain2,long2;

const LineInitial=#1; CommentMedial=#2; TextMedial=#3;
    bufSize=4096;
type aCharType= array[char] of boolean;
var inFile,outFile: longText;
    inFilename,outFileName,punctuation,comment: string;
    buffer: chain;
    numRead: word;
    isPunctuation,
    isComment: aCharType;

function fileExists(fn: string): boolean;
var f: file;
begin assign(f,fn); {$I-} reset(f); {$I+}
      if IOResult=0 then
      begin fileExists:=true; close(f)
      end
      else fileExists:=false;
end;


procedure getParameters;
begin if ParamCount<>3 then
      begin writeln('Usage: ');
            writeln('VSPLIT <input file> <punctuation> <open comment>');
            writeln('For example:');
            writeln('VSPLIT VOYNICH.CUR  ., #');
            halt;
      end else
      begin inFileName:=ParamStr(1);
            punctuation:=ParamStr(2);
            comment:=ParamStr(3);
            if not FileExists(inFileName) then inFileName:='';
      end
end;

procedure Segment(var f: longText; var ch: chain);
var lineType,nextLineType: char;
    Lo,Hi,oldHi: word;
    space,i,n: word;
    canSplit: boolean;
    c: char;
begin lo:=ch.Lo; oldHi:=ch.Hi;
      if isComment[ch.Body_^[ch.lo]]
      then nextLineType:=#2
      else nextLineType:=#3;
      lineType:=#1;
      repeat
             i:=ch.Lo; space:=i; n:=1;
             if i<oldHi then
             repeat inc(i); inc(n); c:=ch.Body_^[i];
                    canSplit:=isPunctuation[c];
		    if canSplit then space:=i
             until (canSplit and (n>=70)) or (i=oldHi);
             if n>250 then ch.Hi:=space else ch.Hi:=i;
             if lineType=#2 then LTWriteChar(f,comment[1]);
             LTWriteChain(f,ch);
             LTWriteChar(f,lineType); (* append #1 for initial *)
                                      (*  #2 or #3 for medial  *)
             LTWriteln(f);
             LineType:=nextLineType;
             ch.Lo:=ch.Hi+1;
      until ch.Lo>oldHi;
end;

procedure Prepare(var c: aCharType; st: string);
var i: byte;
begin fillChar(c,SizeOf(aCharType),false);
       for i:=1 to length(st) do c[st[i]]:=true;
end;

begin getParameters;
      if infileName='' then
      begin writeln(infileName+' not found.');
            halt
      end;
      Prepare(isPunctuation,punctuation);
      isPunctuation[' ']:=true;
      isPunctuation[#13]:=true;
      Prepare(isComment,comment);
      LTAssign(infile,inFileName,4096);
      LTAssign(outfile,'TMP.IN',4096);
      LTReset(infile); LTRewrite(outfile);
      buffer.Init(' ');
      while not LTEof(infile) do
      begin LTReadChain(infile,buffer);
            Segment(outFile,buffer);
      end;
      LTClose(infile);
      LTClose(outfile);
      Buffer.ReInit('');
end.